<?php

/**
 * Plugin Name: mPress Custom Feed Excerpts
 * Description: Customize your feed excerpts using the &lt;!-- more --&gt; tag in posts.  Full text feeds must be enabled.
 * Plugin URI: http://micahwood.me/wordpress-plugins/mpress-feed-excerpt/
 * Author: Micah Wood
 * Author URI: http://micahwood.me
 * Version: 0.2
 * License: GPL3
 * License URI: http://www.gnu.org/licenses/gpl-3.0.html
 *
 * Copyright 2012 by Micah Wood - All rights reserved.
 */

define( 'MPRESS_CUSTOM_FEED_EXCERPTS_VERSION', '0.2' );

if ( ! class_exists( 'mPress_Custom_Feed_Excerpts' ) ) {

	class mPress_Custom_Feed_Excerpts {

		private static $instance;

		public static function get_instance() {
			return self::$instance ? self::$instance : new self();
		}

		private function __construct() {
			self::$instance = $this;
			add_filter('the_content_feed', array( $this, 'the_content_feed' ), 10, 2 );
		}

		public function the_content_feed( $content, $feed_type ) {
			if( ! get_option( 'rss_use_excerpt' ) ) {
				if( $split = preg_split( '#<span id=\"more-\d+\"><\/span>#', $content, 2, PREG_SPLIT_NO_EMPTY ) ) {
					$content = balanceTags( $split[0] . $this->continue_reading_link(), true );
				}
			}
			return $content;
		}

        public function continue_reading_link() {
            $link = ' <a href="'. get_permalink() .'">'. __( 'continue reading', 'mpress-custom-feed-excerpts' ) .'</a>';
            return apply_filters( 'mpress_custom_feed_excerpts_continue_reading_link', $link );
        }

	}

	add_action( 'plugins_loaded', array( 'mPress_Custom_Feed_Excerpts', 'get_instance' ) );

}